#include <tchar.h>
#include <windows.h>
#include <iostream>
#include <string>

using namespace std;

bool newCommand = false;
string i;

BOOL initSerial(HANDLE hCommPort);
DWORD WINAPI inputThread(LPVOID lpParameter);

BOOL initSerial(HANDLE hCommPort) {
	DCB dcb;
	memset(&dcb,0,sizeof(dcb));
	dcb.DCBlength=sizeof(dcb);
	if (!BuildCommDCB(_T("baud=9600 parity=N data=8 stop=1"),&dcb))
	{
		return false;
	}

	// Common settings
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.fAbortOnError = FALSE;
	return SetCommState(hCommPort,&dcb);
}

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hCommPort = CreateFile(_T("COM1"), GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
	FILE_FLAG_OVERLAPPED, NULL);
	if (hCommPort == INVALID_HANDLE_VALUE) return 1;

	if (!initSerial(hCommPort)) return 1;

	HANDLE hThread = CreateThread(NULL, 0, inputThread, NULL, 0, NULL);

	DWORD dwRead;
	char buf[1];
	OVERLAPPED osReader = {0};
	osReader.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	
	bool running = true;
	while(running) {
		
		ReadFile(hCommPort, buf, 1, &dwRead, &osReader);
		while(!HasOverlappedIoCompleted(&osReader) || !running) {
			if (newCommand) {
				newCommand = false;
				char buf[]={'a'};
				if (i.compare("on")==0) buf[0] = 'a'; 
				if (i.compare("off")==0) buf[0] = 'b';
				if (i.compare("q")==0) {
					running = false;
					break;
				}
				DWORD written;
				OVERLAPPED osWriter = {0};
				osReader.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
				WriteFile(hCommPort, buf, 1, &written, &osWriter);
				WaitForSingleObject(osWriter.hEvent, 100);
			}
		}

		if (running)
			if (GetOverlappedResult(hCommPort, &osReader, &dwRead, FALSE))
				cout << buf[0] << endl;
		
	}
	CloseHandle(hCommPort);
	cout << "Exiting." << endl;
}

DWORD WINAPI inputThread(LPVOID lpParameter){
	while(i.compare("q")!=0){
		cin >> i;
		newCommand = true;
	}
	return 0;
}
